/* rn - file sequence renumber for FujiXerox XD530(=FujiFilm DS300) */
/* V002 imaizumi@nisiq.net */
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <direct.h>
#include <time.h>
#include <string.h>
#include <ctype.h>

FILE *fd;
char buf[7];
char newname[14];

void seqname(char *fname)
{
    int i;
    char *p,*q;

    if ((p = strrchr(fname,'.')) == NULL)
        return;
    if ((fd = fopen(fname,"rb"))==NULL) {
        fprintf(stderr,"Error: File '%s' can't open.\n",fname);
        return;
    }
    q = ".jpg";
    if (stricmp(p,q) == 0) {
        fseek(fd,6,SEEK_SET);
        fread(buf,1,4,fd);
       if (strncmp(buf,"Exif",4) == 0) {
            fseek(fd,0xb6,SEEK_SET);
            fread(buf,1,6,fd);
            buf[6] = '\0';
            for(i=0;buf[i];++i) {
                if (isdigit(buf[i]) == 0) {
                    buf[0] = '\0';
                    break;
                }
            }
        } else {
            buf[0] = '\0';
        }
    } else {
        q = ".tif";
        if (stricmp(p,q) == 0) {
            fseek(fd,0x12E,SEEK_SET);
            fread(buf,1,6,fd);
            buf[6] = '\0';
            for(i=0;buf[i];++i) {
                if (isdigit(buf[i]) == 0) {
                    buf[0] = '\0';
                    break;
                }
            }
        }
    }
    fclose(fd);
    if (buf[0] != '\0') {
        sprintf(newname,"dsc%s%s",&buf[1],q);
        if( (rename( fname, newname )) != 0)
            printf( "Error: can't rename '%s'\n", fname );
        else
            printf("rename %s -> %s\n",fname,newname);
    }
}

struct _finddata_t c_file;
long hFile;

void main(int argc,char *argv[] ){

    if (argc > 1)
        if (_chdir(argv[1])!=0) {
            fprintf(stderr,"Error: can't cd '%s'\n",argv[1]);
            exit(1);
        }

    if( (hFile = _findfirst( "DSC*.jpg", &c_file )) != -1L ) {
        do {
            seqname(c_file.name);
        } while( _findnext( hFile, &c_file ) == 0 ) ;
       _findclose( hFile );
   }
    if( (hFile = _findfirst( "DSC*.tif", &c_file )) != -1L ) {
        do {
            seqname(c_file.name);
        } while( _findnext( hFile, &c_file ) == 0 ) ;
       _findclose( hFile );
   }
}
